/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.61 Revision 1.148
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.61 2007/01/04 14:56:46 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.148 2012/07/24 19:22:22 grobian Exp $
4# 4
5# Author: Diego Pettenò <flameeyes@gentoo.org> 5# @ECLASS: autotools.eclass
6# Enhancements: Martin Schlemmer <azarah@gentoo.org> 6# @MAINTAINER:
7# 7# base-system@gentoo.org
8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION:
8# This eclass is for handling autotooled software packages that 10# This eclass is for safely handling autotooled software packages that need to
9# needs to regenerate their build scripts. 11# regenerate their build scripts. All functions will abort in case of errors.
10#
11# NB: If you add anything, please comment it!
12 12
13inherit eutils libtool 13# Note: We require GNU m4, as does autoconf. So feel free to use any features
14# from the GNU version of m4 without worrying about other variants (i.e. BSD).
15
16if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
17___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
18
19inherit libtool multiprocessing
20
21# @ECLASS-VARIABLE: WANT_AUTOCONF
22# @DESCRIPTION:
23# The major version of autoconf your package needs
24: ${WANT_AUTOCONF:=latest}
25
26# @ECLASS-VARIABLE: WANT_AUTOMAKE
27# @DESCRIPTION:
28# The major version of automake your package needs
29: ${WANT_AUTOMAKE:=latest}
30
31# @ECLASS-VARIABLE: WANT_LIBTOOL
32# @DESCRIPTION:
33# Do you want libtool? Valid values here are "latest" and "none".
34: ${WANT_LIBTOOL:=latest}
35
36# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
37# @INTERNAL
38# @DESCRIPTION:
39# CONSTANT!
40# The latest major version/slot of automake available on each arch. #312315
41# If a newer slot is stable on any arch, and is NOT reflected in this list,
42# then circular dependencies may arise during emerge @system bootstraps.
43# Do NOT change this variable in your ebuilds!
44# If you want to force a newer minor version, you can specify the correct
45# WANT value by using a colon: <PV>:<WANT_AUTOMAKE>
46_LATEST_AUTOMAKE=( 1.11.1:1.11 1.12:1.12 )
14 47
15_automake_atom="sys-devel/automake" 48_automake_atom="sys-devel/automake"
16_autoconf_atom="sys-devel/autoconf" 49_autoconf_atom="sys-devel/autoconf"
17if [[ -n ${WANT_AUTOMAKE} ]]; then 50if [[ -n ${WANT_AUTOMAKE} ]]; then
18 case ${WANT_AUTOMAKE} in 51 case ${WANT_AUTOMAKE} in
19 # workaround while we have different versions of automake in arch and ~arch 52 # Even if the package doesn't use automake, we still need to depend
20 latest) _automake_atom="|| ( =sys-devel/automake-1.10* =sys-devel/automake-1.9* )" ;; 53 # on it because we run aclocal to process m4 macros. This matches
54 # the autoreconf tool, so this requirement is correct. #401605
55 none) ;;
56 latest)
57 # Use SLOT deps if we can. For EAPI=0, we get pretty close.
58 if [[ ${EAPI:-0} != 0 ]] ; then
59 _automake_atom="|| ( `printf '>=sys-devel/automake-%s:%s ' ${_LATEST_AUTOMAKE[@]/:/ }` )"
60 else
61 _automake_atom="|| ( `printf '>=sys-devel/automake-%s ' ${_LATEST_AUTOMAKE[@]/%:*}` )"
62 fi
63 ;;
21 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 64 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
22 esac 65 esac
66 export WANT_AUTOMAKE
23fi 67fi
24 68
25if [[ -n ${WANT_AUTOCONF} ]] ; then 69if [[ -n ${WANT_AUTOCONF} ]] ; then
26 case ${WANT_AUTOCONF} in 70 case ${WANT_AUTOCONF} in
71 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
27 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 72 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
73 # if you change the "latest" version here, change also autotools_env_setup
28 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;; 74 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.68" ;;
75 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
29 esac 76 esac
77 export WANT_AUTOCONF
30fi 78fi
31DEPEND="${_automake_atom} 79
32 ${_autoconf_atom} 80_libtool_atom="sys-devel/libtool"
33 sys-devel/libtool" 81if [[ -n ${WANT_LIBTOOL} ]] ; then
82 case ${WANT_LIBTOOL} in
83 none) _libtool_atom="" ;;
84 latest) ;;
85 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
86 esac
87 export WANT_LIBTOOL
88fi
89
90AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
34RDEPEND="" 91RDEPEND=""
92
93# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
94# @DESCRIPTION:
95# Set to 'no' to disable automatically adding to DEPEND. This lets
96# ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
97# their own DEPEND string.
98: ${AUTOTOOLS_AUTO_DEPEND:=yes}
99if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
100 DEPEND=${AUTOTOOLS_DEPEND}
101fi
102
35unset _automake_atom _autoconf_atom 103unset _automake_atom _autoconf_atom
36 104
37# Variables: 105# @ECLASS-VARIABLE: AM_OPTS
38# 106# @DEFAULT_UNSET
39# AT_M4DIR - Additional director(y|ies) aclocal should search 107# @DESCRIPTION:
40# AM_OPTS - Additional options to pass to automake during 108# Additional options to pass to automake during
41# eautoreconf call. 109# eautoreconf call.
110
111# @ECLASS-VARIABLE: AT_NOEAUTOMAKE
112# @DEFAULT_UNSET
113# @DESCRIPTION:
114# Don't run eautomake command if set to 'yes'; only used to workaround
115# broken packages. Generally you should, instead, fix the package to
116# not call AM_INIT_AUTOMAKE if it doesn't actually use automake.
117
118# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
119# @DEFAULT_UNSET
120# @DESCRIPTION:
42# AT_NOELIBTOOLIZE - Don't run elibtoolize command if set to 'yes', 121# Don't run elibtoolize command if set to 'yes',
43# useful when elibtoolize needs to be ran with 122# useful when elibtoolize needs to be ran with
44# particular options 123# particular options
45 124
46# Functions: 125# @ECLASS-VARIABLE: AT_M4DIR
47# 126# @DESCRIPTION:
48# eautoreconf() - Should do a full autoreconf - normally what most people 127# Additional director(y|ies) aclocal should search
49# will be interested in. Also should handle additional 128: ${AT_M4DIR:=}
50# directories specified by AC_CONFIG_SUBDIRS.
51# eaclocal() - Runs aclocal. Respects AT_M4DIR for additional directories
52# to search for macro's.
53# _elibtoolize() - Runs libtoolize. Note the '_' prefix .. to not collide
54# with elibtoolize() from libtool.eclass
55# eautoconf - Runs autoconf.
56# eautoheader - Runs autoheader.
57# eautomake - Runs automake
58#
59 129
60# XXX: M4DIR should be depreciated 130# @ECLASS-VARIABLE: AT_SYS_M4DIR
61AT_M4DIR=${AT_M4DIR:-${M4DIR}} 131# @INTERNAL
62AT_GNUCONF_UPDATE="no" 132# @DESCRIPTION:
133# For system integrators, a list of additional aclocal search paths.
134# This variable gets eval-ed, so you can use variables in the definition
135# that may not be valid until eautoreconf & friends are run.
136: ${AT_SYS_M4DIR:=}
63 137
64 138# @FUNCTION: eautoreconf
139# @DESCRIPTION:
65# This function mimes the behavior of autoreconf, but uses the different 140# This function mimes the behavior of autoreconf, but uses the different
66# eauto* functions to run the tools. It doesn't accept parameters, but 141# eauto* functions to run the tools. It doesn't accept parameters, but
67# the directory with include files can be specified with AT_M4DIR variable. 142# the directory with include files can be specified with AT_M4DIR variable.
143#
144# Should do a full autoreconf - normally what most people will be interested in.
145# Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
68eautoreconf() { 146eautoreconf() {
69 local pwd=$(pwd) x auxdir 147 local x g multitop
70 148
149 if [[ -z ${AT_TOPLEVEL_EAUTORECONF} ]] ; then
150 AT_TOPLEVEL_EAUTORECONF="yes"
151 multitop="yes"
152 multijob_init
153 fi
154
71 if [[ -z ${AT_NO_RECURSIVE} ]]; then 155 if [[ -z ${AT_NO_RECURSIVE} ]] ; then
72 # Take care of subdirs 156 # Take care of subdirs
73 for x in $(autotools_get_subdirs); do 157 for x in $(autotools_check_macro_val AC_CONFIG_SUBDIRS) ; do
74 if [[ -d ${x} ]] ; then 158 if [[ -d ${x} ]] ; then
75 cd "${x}" 159 pushd "${x}" >/dev/null
76 AT_NOELIBTOOLIZE="yes" eautoreconf 160 AT_NOELIBTOOLIZE="yes" multijob_child_init eautoreconf || die
77 cd "${pwd}" 161 popd >/dev/null
78 fi 162 fi
79 done 163 done
80 fi 164 fi
81 165
82 auxdir=$(autotools_get_auxdir)
83
84 einfo "Running eautoreconf in '$(pwd)' ..." 166 einfo "Running eautoreconf in '${PWD}' ..."
167
168 local m4dirs=$(autotools_check_macro_val AC_CONFIG_{AUX,MACRO}_DIR)
85 [[ -n ${auxdir} ]] && mkdir -p ${auxdir} 169 [[ -n ${m4dirs} ]] && mkdir -p ${m4dirs}
170
171 # Run all the tools before aclocal so we can gather the .m4 files.
172 local i tools=(
173 # <tool> <was run> <command>
174 glibgettext false "autotools_run_tool glib-gettextize --copy --force"
175 gettext false "autotools_run_tool --at-missing autopoint --force"
176 # intltool must come after autopoint.
177 intltool false "autotools_run_tool intltoolize --automake --copy --force"
178 gtkdoc false "autotools_run_tool --at-missing gtkdocize --copy"
179 gnomedoc false "autotools_run_tool --at-missing gnome-doc-prepare --copy --force"
180 libtool false "_elibtoolize --install --copy --force"
181 )
182 for (( i = 0; i < ${#tools[@]}; i += 3 )) ; do
183 if _at_uses_${tools[i]} ; then
184 tools[i+1]=true
185 ${tools[i+2]}
186 fi
187 done
188
189 # Generate aclocal.m4 with our up-to-date m4 files.
190 local rerun_aclocal=false
86 eaclocal 191 eaclocal
87 _elibtoolize --copy --force 192
193 # Check to see if we had macros expanded by other macros or in other
194 # m4 files that we couldn't detect early. This is uncommon, but some
195 # packages do this, so we have to handle it correctly.
196 for (( i = 0; i < ${#tools[@]}; i += 3 )) ; do
197 if ! ${tools[i+1]} && _at_uses_${tools[i]} ; then
198 ${tools[i+2]}
199 rerun_aclocal=true
200 fi
201 done
202 ${rerun_aclocal} && eaclocal
203
88 eautoconf 204 eautoconf
89 eautoheader 205 eautoheader
90 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS} 206 [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
91 207
92 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0 208 if [[ ${AT_NOELIBTOOLIZE} != "yes" ]] ; then
93
94 # Call it here to prevent failures due to elibtoolize called _before_ 209 # Call it here to prevent failures due to elibtoolize called _before_
95 # eautoreconf. 210 # eautoreconf. We set $S because elibtoolize runs on that #265319
96 elibtoolize 211 S=${PWD} elibtoolize --force
212 fi
213
214 if [[ -n ${multitop} ]] ; then
215 unset AT_TOPLEVEL_EAUTORECONF
216 multijob_finish || die
217 fi
97 218
98 return 0 219 return 0
99} 220}
100 221
222# @FUNCTION: _at_uses_pkg
223# @USAGE: <macros>
224# @INTERNAL
225# See if the specified macros are enabled.
226_at_uses_pkg() {
227 if [[ -n $(autotools_check_macro "$@") ]] ; then
228 return 0
229 else
230 # If the trace didn't find it (perhaps because aclocal.m4 hasn't
231 # been generated yet), cheat, but be conservative.
232 local macro args=()
233 for macro ; do
234 args+=( -e "^[[:space:]]*${macro}\>" )
235 done
236 egrep -q "${args[@]}" configure.??
237 fi
238}
239_at_uses_autoheader() { _at_uses_pkg AC_CONFIG_HEADERS; }
240_at_uses_automake() { _at_uses_pkg AM_INIT_AUTOMAKE; }
241_at_uses_gettext() { _at_uses_pkg AM_GNU_GETTEXT_VERSION; }
242_at_uses_glibgettext() { _at_uses_pkg AM_GLIB_GNU_GETTEXT; }
243_at_uses_intltool() { _at_uses_pkg {AC,IT}_PROG_INTLTOOL; }
244_at_uses_gtkdoc() { _at_uses_pkg GTK_DOC_CHECK; }
245_at_uses_gnomedoc() { _at_uses_pkg GNOME_DOC_INIT; }
246_at_uses_libtool() { _at_uses_pkg A{C,M}_PROG_LIBTOOL LT_INIT; }
247
248# @FUNCTION: eaclocal_amflags
249# @DESCRIPTION:
250# Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
251# (most) of the crazy crap that people throw at us.
252eaclocal_amflags() {
253 local aclocal_opts amflags_file
254
255 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
256 [[ -e ${amflags_file} ]] || continue
257 # setup the env in case the pkg does something crazy
258 # in their ACLOCAL_AMFLAGS. like run a shell script
259 # which turns around and runs autotools. #365401
260 # or split across multiple lines. #383525
261 autotools_env_setup
262 aclocal_opts=$(sed -n \
263 "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
264 # match the first line
265 s:[^=]*=::p; \
266 # then gobble up all escaped lines
267 : nextline /\\\\$/{ n; p; b nextline; } \
268 }" ${amflags_file})
269 eval aclocal_opts=\""${aclocal_opts}"\"
270 break
271 done
272
273 echo ${aclocal_opts}
274}
275
276# @FUNCTION: eaclocal
277# @DESCRIPTION:
101# These functions runs the autotools using autotools_run_tool with the 278# These functions runs the autotools using autotools_run_tool with the
102# specified parametes. The name of the tool run is the same of the function 279# specified parametes. The name of the tool run is the same of the function
103# without e prefix. 280# without e prefix.
104# They also force installing the support files for safety. 281# They also force installing the support files for safety.
282# Respects AT_M4DIR for additional directories to search for macro's.
105eaclocal() { 283eaclocal() {
106 local aclocal_opts
107
108 if [[ -n ${AT_M4DIR} ]] ; then
109 for x in ${AT_M4DIR} ; do
110 case "${x}" in
111 "-I")
112 # We handle it below
113 ;;
114 *)
115 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
116 aclocal_opts="${aclocal_opts} -I ${x}"
117 ;;
118 esac
119 done
120 fi
121
122 autotools_set_versions
123 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 284 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
124 autotools_run_tool aclocal "$@" ${aclocal_opts} 285 autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
125} 286}
126 287
288# @FUNCTION: _elibtoolize
289# @DESCRIPTION:
290# Runs libtoolize. If --install is the first arg, automatically drop it if
291# the active libtool version doesn't support it.
292#
293# Note the '_' prefix .. to not collide with elibtoolize() from libtool.eclass.
127_elibtoolize() { 294_elibtoolize() {
128 local opts 295 local LIBTOOLIZE=${LIBTOOLIZE:-$(type -P glibtoolize > /dev/null && echo glibtoolize || echo libtoolize)}
129 local lttest
130 296
131 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro, 297 [[ -f GNUmakefile.am || -f Makefile.am ]] && set -- "$@" --automake
132 # check for both it and the current AC_PROG_LIBTOOL) 298 if [[ $1 == "--install" ]] ; then
133 lttest="$(autotools_check_macro "AC_PROG_LIBTOOL")$(autotools_check_macro "AM_PROG_LIBTOOL")" 299 ${LIBTOOLIZE} -n --install >& /dev/null || shift
134 [[ -n $lttest ]] || return 0 300 fi
135 301
136 [[ -f Makefile.am ]] && opts="--automake"
137
138 [[ "${USERLAND}" == "Darwin" ]] && LIBTOOLIZE="glibtoolize"
139 autotools_run_tool ${LIBTOOLIZE:-libtoolize} "$@" ${opts} 302 autotools_run_tool ${LIBTOOLIZE} "$@" ${opts}
140
141 # Need to rerun aclocal
142 eaclocal
143} 303}
144 304
305# @FUNCTION: eautoheader
306# @DESCRIPTION:
307# Runs autoheader.
145eautoheader() { 308eautoheader() {
146 # Check if we should run autoheader 309 _at_uses_autoheader || return 0
147 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 310 autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
148 autotools_set_versions
149 NO_FAIL=1 autotools_run_tool autoheader "$@"
150} 311}
151 312
313# @FUNCTION: eautoconf
314# @DESCRIPTION:
315# Runs autoconf.
152eautoconf() { 316eautoconf() {
153 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 317 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
154 echo 318 echo
155 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!" 319 eerror "No configure.{ac,in} present in '${PWD}'!"
156 echo 320 echo
157 die "No configure.{ac,in} present!" 321 die "No configure.{ac,in} present!"
158 fi 322 fi
159 323
160 autotools_set_versions
161 autotools_run_tool autoconf "$@" 324 autotools_run_tool --at-m4flags autoconf "$@"
162} 325}
163 326
327# @FUNCTION: eautomake
328# @DESCRIPTION:
329# Runs automake.
164eautomake() { 330eautomake() {
165 local extra_opts 331 local extra_opts
332 local makefile_name
166 333
167 [[ -f Makefile.am ]] || return 0 334 # Run automake if:
335 # - a Makefile.am type file exists
336 # - the configure script is using the AM_INIT_AUTOMAKE directive
337 for makefile_name in {GNUmakefile,{M,m}akefile}.am "" ; do
338 [[ -f ${makefile_name} ]] && break
339 done
168 340
169 autotools_set_versions 341 if [[ -z ${makefile_name} ]] ; then
342 _at_uses_automake || return 0
343
170 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then 344 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
171 local used_automake 345 local used_automake
172 local installed_automake 346 local installed_automake
173 347
174 installed_automake=$(automake --version | head -n 1 | \ 348 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
175 sed -e 's:.*(GNU automake) ::') 349 sed -e 's:.*(GNU automake) ::')
176 used_automake=$(head -n 1 < Makefile.in | \ 350 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
177 sed -e 's:.*by automake \(.*\) from .*:\1:') 351 sed -e 's:.*by automake \(.*\) from .*:\1:')
178 352
179 if [[ ${installed_automake} != ${used_automake} ]]; then 353 if [[ ${installed_automake} != ${used_automake} ]]; then
180 einfo "Automake used for the package (${used_automake}) differs from" 354 einfo "Automake used for the package (${used_automake}) differs from"
181 einfo "the installed version (${installed_automake})." 355 einfo "the installed version (${installed_automake})."
182 eautoreconf 356 eautoreconf
183 return 0 357 return 0
184 fi 358 fi
185 fi 359 fi
186 360
187 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \ 361 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
188 || extra_opts="${extra_opts} --foreign" 362 || extra_opts="${extra_opts} --foreign"
189 363
190 # --force-missing seems not to be recognized by some flavours of automake 364 # --force-missing seems not to be recognized by some flavours of automake
191 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 365 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
192} 366}
193 367
194autotools_set_versions() { 368# @FUNCTION: eautopoint
195 [[ -n ${autotools_version_sets} ]] && return 0 369# @DESCRIPTION:
370# Runs autopoint (from the gettext package).
371eautopoint() {
372 autotools_run_tool autopoint "$@"
373}
196 374
197 if [[ -n ${WANT_AUTOCONF} ]]; then 375# @FUNCTION: config_rpath_update
198 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5" 376# @USAGE: [destination]
199 export WANT_AUTOCONF 377# @DESCRIPTION:
200 einfo "Requested autoconf ${WANT_AUTOCONF}" 378# Some packages utilize the config.rpath helper script, but don't
201 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)" 379# use gettext directly. So we have to copy it in manually since
202 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)" 380# we can't let `autopoint` do it for us.
203 else 381config_rpath_update() {
204 ewarn "QA Notice: \${WANT_AUTOCONF} variable unset. Please report on http://bugs.gentoo.org/" 382 local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:')
205 fi
206 383
207 if [[ -n ${WANT_AUTOMAKE} ]]; then 384 [[ $# -eq 0 ]] && set -- $(find -name config.rpath)
208 local latest_automake 385 [[ $# -eq 0 ]] && return 0
386
387 einfo "Updating all config.rpath files"
388 for dst in "$@" ; do
389 einfo " ${dst}"
390 cp "${src}" "${dst}" || die
391 done
392}
393
394# @FUNCTION: autotools_env_setup
395# @INTERNAL
396# @DESCRIPTION:
397# Process the WANT_AUTO{CONF,MAKE} flags.
398autotools_env_setup() {
399 # We do the "latest" → version switch here because it solves
400 # possible order problems, see bug #270010 as an example.
209 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then 401 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
210 latest_automake="latest: " 402 local pv
211 for amver in 1.10 1.9 1.8 1.7 1.6; do 403 for pv in ${_LATEST_AUTOMAKE[@]/#*:} ; do
212 WANT_AUTOMAKE="${amver}" 404 # has_version respects ROOT, but in this case, we don't want it to,
213 ROOT=/ has_version =sys-devel/automake-${amver}* && break 405 # thus "ROOT=/" prefix:
406 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="${pv}"
214 done 407 done
408 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
409 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
215 fi 410 fi
216 export WANT_AUTOMAKE 411 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
217 einfo "Requested automake ${latest_automake}${WANT_AUTOMAKE}"
218 einfo "Using $(automake --version 2>/dev/null | head -n 1)"
219 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)"
220 else
221 ewarn "QA Notice: \${WANT_AUTOMAKE} variable unset. Please report on http://bugs.gentoo.org/"
222 fi
223
224 autotools_version_sets="yes"
225} 412}
226 413
227# Internal function to run an autotools' tool 414# @FUNCTION: autotools_run_tool
415# @USAGE: [--at-no-fail] [--at-m4flags] [--at-missing] <autotool> [tool-specific flags]
416# @INTERNAL
417# @DESCRIPTION:
418# Run the specified autotool helper, but do logging and error checking
419# around it in the process.
228autotools_run_tool() { 420autotools_run_tool() {
421 # Process our own internal flags first
422 local autofail=true m4flags=false missing_ok=false
423 while [[ -n $1 ]] ; do
424 case $1 in
425 --at-no-fail) autofail=false;;
426 --at-m4flags) m4flags=true;;
427 --at-missing) missing_ok=true;;
428 # whatever is left goes to the actual tool
429 *) break;;
430 esac
431 shift
432 done
433
434 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
435 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
436 fi
437
438 if ${missing_ok} && ! type -P ${1} >/dev/null ; then
439 einfo "Skipping '$*' due $1 not installed"
440 return 0
441 fi
442
443 autotools_env_setup
444
229 local STDERR_TARGET="${T}/$$.out" 445 local STDERR_TARGET="${T}/$1.out"
446 # most of the time, there will only be one run, but if there are
447 # more, make sure we get unique log filenames
448 if [[ -e ${STDERR_TARGET} ]] ; then
230 local ris 449 local i=1
450 while :; do
451 STDERR_TARGET="${T}/$1-${i}.out"
452 [[ -e ${STDERR_TARGET} ]] || break
453 : $(( i++ ))
454 done
455 fi
231 456
232 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 457 if ${m4flags} ; then
233 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 458 set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include)
459 fi
460
461 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
234 462
235 ebegin "Running $@" 463 ebegin "Running $@"
236 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1 464 "$@" >> "${STDERR_TARGET}" 2>&1
237 ris=$? 465 if ! eend $? && ${autofail} ; then
238 eend ${ris}
239
240 if [[ ${ris} != 0 && ${NO_FAIL} != 1 ]]; then
241 echo 466 echo
242 eerror "Failed Running $1 !" 467 eerror "Failed Running $1 !"
243 eerror 468 eerror
244 eerror "Include in your bugreport the contents of:" 469 eerror "Include in your bugreport the contents of:"
245 eerror 470 eerror
246 eerror " ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}" 471 eerror " ${STDERR_TARGET}"
247 echo 472 echo
248 die "Failed Running $1 !" 473 die "Failed Running $1 !"
249 fi 474 fi
250} 475}
251 476
252# Internal function to check for support 477# Internal function to check for support
478
479# Keep a list of all the macros we might use so that we only
480# have to run the trace code once. Order doesn't matter.
481ALL_AUTOTOOLS_MACROS=(
482 AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT
483 AC_CONFIG_HEADERS
484 AC_CONFIG_SUBDIRS
485 AC_CONFIG_AUX_DIR AC_CONFIG_MACRO_DIR
486 AM_INIT_AUTOMAKE
487 AM_GLIB_GNU_GETTEXT
488 AM_GNU_GETTEXT_VERSION
489 {AC,IT}_PROG_INTLTOOL
490 GTK_DOC_CHECK
491 GNOME_DOC_INIT
492)
253autotools_check_macro() { 493autotools_check_macro() {
254 [[ -f configure.ac || -f configure.in ]] && \ 494 [[ -f configure.ac || -f configure.in ]] || return 0
255 WANT_AUTOCONF="2.5" autoconf --trace=$1 2>/dev/null 495
496 # We can run in multiple dirs, so we have to cache the trace
497 # data in $PWD rather than an env var.
498 local trace_file=".__autoconf_trace_data"
499 if [[ ! -e ${trace_file} ]] || [[ aclocal.m4 -nt ${trace_file} ]] ; then
500 WANT_AUTOCONF="2.5" autoconf \
501 $(autotools_m4dir_include) \
502 ${ALL_AUTOTOOLS_MACROS[@]/#/--trace=} > ${trace_file} 2>/dev/null
503 fi
504
505 local macro args=()
506 for macro ; do
507 has ${macro} ${ALL_AUTOTOOLS_MACROS[@]} || die "internal error: add ${macro} to ALL_AUTOTOOLS_MACROS"
508 args+=( -e ":${macro}:" )
509 done
510 grep "${args[@]}" ${trace_file}
511}
512
513# @FUNCTION: autotools_check_macro_val
514# @USAGE: <macro> [macros]
515# @INTERNAL
516# @DESCRIPTION:
517# Look for a macro and extract its value.
518autotools_check_macro_val() {
519 local macro scan_out
520
521 for macro ; do
522 autotools_check_macro "${macro}" | \
523 gawk -v macro="${macro}" \
524 '($0 !~ /^[[:space:]]*(#|dnl)/) {
525 if (match($0, macro ":(.*)$", res))
526 print res[1]
527 }' | uniq
528 done
529
256 return 0 530 return 0
257} 531}
258 532
259# Internal function to get additional subdirs to configure 533_autotools_m4dir_include() {
260autotools_get_subdirs() { 534 local x include_opts
261 local subdirs_scan_out
262 535
263 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS") 536 for x in "$@" ; do
264 [[ -n ${subdirs_scan_out} ]] || return 0 537 case ${x} in
538 # We handle it below
539 -I) ;;
540 *)
541 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
542 include_opts+=" -I ${x}"
543 ;;
544 esac
545 done
265 546
266 echo "${subdirs_scan_out}" | gawk \ 547 echo ${include_opts}
267 '($0 !~ /^[[:space:]]*(#|dnl)/) {
268 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res))
269 print res[1]
270 }' | uniq
271
272 return 0
273} 548}
549autotools_m4dir_include() { _autotools_m4dir_include ${AT_M4DIR} ; }
550autotools_m4sysdir_include() { _autotools_m4dir_include $(eval echo ${AT_SYS_M4DIR}) ; }
274 551
275autotools_get_auxdir() { 552fi
276 local auxdir_scan_out
277
278 auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
279 [[ -n ${auxdir_scan_out} ]] || return 0
280
281 echo ${auxdir_scan_out} | gawk \
282 '($0 !~ /^[[:space:]]*(#|dnl)/) {
283 if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
284 print res[1]
285 }' | uniq
286
287 return 0
288}

Legend:
Removed from v.1.61  
changed lines
  Added in v.1.148

  ViewVC Help
Powered by ViewVC 1.1.20